JspCompilationContext (Apache Tomcat 11.0.8 API Documentation)
Description: declaration: package: org.apache.jasper, class: JspCompilationContext

# Class JspCompilationContext

java.lang.Object
org.apache.jasper.JspCompilationContext

public class JspCompilationContext extends Object
A placeholder for various things that are used throughout the JSP engine. This is a per-request/per-context data structure. Some of the instance variables are set at different points. Most of the path-related stuff is here - mangling names, versions, dirs, loading resources and dealing with uris.

Author:
  Anil K. Vijendran, Harish Prabandham, Pierre Delisle, Costin Manolache, Kin-man Chung

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `JspCompilationContext(String tagfile, TagInfo tagInfo, Options options, ServletContext context, JspServletWrapper jsw, JspRuntimeContext rctxt, Jar tagJar)`
  `JspCompilationContext(String jspUri, Options options, ServletContext context, JspServletWrapper jsw, JspRuntimeContext rctxt)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected static String`
  `canonicalURI(String s)`
  `void`
  `checkOutputDir()`
  `void`
  `clearJspLoader()`
  `void`
  `compile()`
  `Compiler`
  `createCompiler()`
  Create a "Compiler" object based on some init param data.
  `protected Compiler`
  `createCompiler(String className)`
  `protected void`
  `createOutputDir()`
  `String`
  `getBasePackageName()`
  `String`
  `getClassFileName()`
  `ClassLoader`
  `getClassLoader()`
  What class loader to use for loading classes while compiling this JSP?
  `String`
  `getClassPath()`
  `Compiler`
  `getCompiler()`
  `protected String`
  `getDerivedPackageName()`
  `String`
  `getFQCN()`
  `String`
  `getJavaPath()`
  `String`
  `getJspFile()`
  Path of the JSP URI.
  `ClassLoader`
  `getJspLoader()`
  `Long`
  `getLastModified(String resource)`
  `Long`
  `getLastModified(String resource, Jar tagJar)`
  `Options`
  `getOptions()`
  `String`
  `getOutputDir()`
  The output directory to generate code into.
  `String`
  `getRealPath(String path)`
  Gets the actual path of a URI relative to the context of the compilation.
  `URL`
  `getResource(String res)`
  `InputStream`
  `getResourceAsStream(String res)`
  Gets a resource as a stream, relative to the meanings of this context's implementation.
  `Set<String>`
  `getResourcePaths(String path)`
  `JspRuntimeContext`
  `getRuntimeContext()`
  `String`
  `getServletClassName()`
  Just the class name (does not include package name) of the generated class.
  `ServletContext`
  `getServletContext()`
  `String`
  `getServletJavaFileName()`
  `String`
  `getServletPackageName()`
  Package name for the generated class is made up of the base package name, which is user settable, and the derived package name.
  `Jar`
  `getTagFileJar()`
  Returns the JAR file in which the tag file for which this JspCompilationContext was created is packaged, or null if this JspCompilationContext does not correspond to a tag file, or if the corresponding tag file is not packaged in a JAR.
  `TagInfo`
  `getTagInfo()`
  `TldResourcePath`
  `getTldResourcePath(String uri)`
  Gets the 'location' of the TLD associated with the given taglib 'uri'.
  `ServletWriter`
  `getWriter()`
  `void`
  `incrementRemoved()`
  `protected static boolean`
  `isPathSeparator(char c)`
  `boolean`
  `isPrototypeMode()`
  `boolean`
  `isRemoved()`
  `boolean`
  `isTagFile()`
  `boolean`
  `keepGenerated()`
  `Class<?>`
  `load()`
  `protected boolean`
  `makeOutputDir()`
  `String`
  `resolveRelativeUri(String uri)`
  Get the full value of a URI relative to this compilations context uses current file as the base.
  `void`
  `setBasePackageName(String basePackageName)`
  The package name into which the servlet class is generated.
  `void`
  `setClassLoader(ClassLoader loader)`
  `void`
  `setClassPath(String classPath)`
  The classpath that is passed off to the Java compiler.
  `void`
  `setPrototypeMode(boolean pm)`
  `void`
  `setServletClassName(String className)`
  `void`
  `setTagFileJar(Jar tagJar)`
  `void`
  `setTagInfo(TagInfo tagi)`
  `void`
  `setWriter(ServletWriter writer)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### JspCompilationContext

    public JspCompilationContext(String jspUri, Options options, ServletContext context, JspServletWrapper jsw, JspRuntimeContext rctxt)

  - ### JspCompilationContext

    public JspCompilationContext(String tagfile, TagInfo tagInfo, Options options, ServletContext context, JspServletWrapper jsw, JspRuntimeContext rctxt, Jar tagJar)

- ## Method Details

  - ### getClassPath

    public String getClassPath()
    Returns:
      the classpath that is passed off to the Java compiler.

  - ### setClassPath

    public void setClassPath(String classPath)
    The classpath that is passed off to the Java compiler.
    Parameters:
      `classPath` - The class path to use

  - ### getClassLoader

    public ClassLoader getClassLoader()
    What class loader to use for loading classes while compiling this JSP?
    Returns:
      the class loader used to load all compiled classes

  - ### setClassLoader

    public void setClassLoader(ClassLoader loader)

  - ### getJspLoader

    public ClassLoader getJspLoader()

  - ### clearJspLoader

    public void clearJspLoader()

  - ### getOutputDir

    public String getOutputDir()
    The output directory to generate code into. The output directory is make up of the scratch directory, which is provided in Options, plus the directory derived from the package name.
    Returns:
      the output directory in which the generated sources are placed

  - ### createCompiler

    public Compiler createCompiler()
    Create a "Compiler" object based on some init param data. This is not done yet. Right now we're just hardcoding the actual compilers that are created.
    Returns:
      the Java compiler wrapper

  - ### createCompiler

    protected Compiler createCompiler(String className)

  - ### getCompiler

    public Compiler getCompiler()

  - ### resolveRelativeUri

    public String resolveRelativeUri(String uri)
    Get the full value of a URI relative to this compilations context uses current file as the base.
    Parameters:
      `uri` - The relative URI
    Returns:
      absolute URI

  - ### getResourceAsStream

    public InputStream getResourceAsStream(String res)
    Gets a resource as a stream, relative to the meanings of this context's implementation.
    Parameters:
      `res` - the resource to look for
    Returns:
      a null if the resource cannot be found or represented as an InputStream.

  - ### getResource

    public URL getResource(String res) throws MalformedURLException
    Throws:
      `MalformedURLException`

  - ### getResourcePaths

    public Set<String> getResourcePaths(String path)

  - ### getRealPath

    public String getRealPath(String path)
    Gets the actual path of a URI relative to the context of the compilation.
    Parameters:
      `path` - The webapp path
    Returns:
      the corresponding path in the filesystem

  - ### getTagFileJar

    public Jar getTagFileJar()
    Returns the JAR file in which the tag file for which this JspCompilationContext was created is packaged, or null if this JspCompilationContext does not correspond to a tag file, or if the corresponding tag file is not packaged in a JAR.
    Returns:
      a JAR file

  - ### setTagFileJar

    public void setTagFileJar(Jar tagJar)

  - ### getServletClassName

    public String getServletClassName()
    Just the class name (does not include package name) of the generated class.
    Returns:
      the class name

  - ### setServletClassName

    public void setServletClassName(String className)

  - ### getJspFile

    public String getJspFile()
    Path of the JSP URI. Note that this is not a file name. This is the context rooted URI of the JSP file.
    Returns:
      the path to the JSP

  - ### getLastModified

    public Long getLastModified(String resource)

  - ### getLastModified

    public Long getLastModified(String resource, Jar tagJar)

  - ### isTagFile

    public boolean isTagFile()

  - ### getTagInfo

    public TagInfo getTagInfo()

  - ### setTagInfo

    public void setTagInfo(TagInfo tagi)

  - ### isPrototypeMode

    public boolean isPrototypeMode()
    Returns:
      `true` if we are compiling a tag file in prototype mode. ie we only generate codes with class for the tag handler with empty method bodies.

  - ### setPrototypeMode

    public void setPrototypeMode(boolean pm)

  - ### getServletPackageName

    public String getServletPackageName()
    Package name for the generated class is made up of the base package name, which is user settable, and the derived package name. The derived package name directly mirrors the file hierarchy of the JSP page.
    Returns:
      the package name

  - ### getDerivedPackageName

    protected String getDerivedPackageName()

  - ### getBasePackageName

    public String getBasePackageName()
    Returns:
      The base package name into which all servlet and associated code is generated

  - ### setBasePackageName

    public void setBasePackageName(String basePackageName)
    The package name into which the servlet class is generated.
    Parameters:
      `basePackageName` - The package name to use

  - ### getServletJavaFileName

    public String getServletJavaFileName()
    Returns:
      Full path name of the Java file into which the servlet is being generated.

  - ### getOptions

    public Options getOptions()
    Returns:
      the Options object for this context.

  - ### getServletContext

    public ServletContext getServletContext()

  - ### getRuntimeContext

    public JspRuntimeContext getRuntimeContext()

  - ### getJavaPath

    public String getJavaPath()
    Returns:
      the path of the Java file relative to the work directory.

  - ### getClassFileName

    public String getClassFileName()

  - ### getWriter

    public ServletWriter getWriter()
    Returns:
      the writer that is used to write the generated Servlet source.

  - ### setWriter

    public void setWriter(ServletWriter writer)

  - ### getTldResourcePath

    public TldResourcePath getTldResourcePath(String uri)
    Gets the 'location' of the TLD associated with the given taglib 'uri'.
    Parameters:
      `uri` - The taglib URI
    Returns:
      An array of two Strings: The first element denotes the real path to the TLD. If the path to the TLD points to a jar file, then the second element denotes the name of the TLD entry in the jar file. Returns null if the given uri is not associated with any tag library 'exposed' in the web application.

  - ### keepGenerated

    public boolean keepGenerated()
    Returns:
      `true` if generated code is kept.

  - ### incrementRemoved

    public void incrementRemoved()

  - ### isRemoved

    public boolean isRemoved()

  - ### compile

    public void compile() throws JasperException, FileNotFoundException
    Throws:
      `JasperException`
      `FileNotFoundException`

  - ### load

    public Class<?> load() throws JasperException
    Throws:
      `JasperException`

  - ### getFQCN

    public String getFQCN()

  - ### checkOutputDir

    public void checkOutputDir()

  - ### makeOutputDir

    protected boolean makeOutputDir()

  - ### createOutputDir

    protected void createOutputDir()

  - ### isPathSeparator

    protected static boolean isPathSeparator(char c)

  - ### canonicalURI

    protected static String canonicalURI(String s)